#ifndef __GLOBALS_H__
#define __GLOBALS_H__

#define PLUGIN_NAME      	"CoverViewer"
#define PROG_NAME	      	"xmms"
#define DISPLAY_LIB	      	"gtk"
//#define __HEAVYDEBUG__    //display a lot of info (filenames, tags, ...)
//#define __DEBUG__ // display state (what's going on, etc...)

#include <gtk/gtk.h>

enum { NONE, MOVE, RESIZE, SCROLLMOUSE, SCROLLBAR, MOVEINDEX };

int xwin, ywin, Xwin, Ywin, posx, posy, Posx, Posy;
int slide_speed, titleheight, lineheight, lyrics_maxlinelength;

// Configuration variables
gchar *fontname, *lyrics_fontname, *title_format, *empty_picture,
	*image_dir, *image_keywords, *search_order, *get_all;
gboolean ratio, slide, conf, skinned, fullscreen, redrawskin, net_search, title_display,
	lock_file, smart_search, album_search, auto_hide, show_button, show_index;
gboolean managing;

gboolean lyrics_display, lyrics_enabled, lyrics_lmbscr;
gchar *lyrics, *lyrics_nobr, *lyrics_websearch_cmd;
gint lyrics_offset, lyrics_offset_h, lyrics_zoom;
gint index_x, index_y;

GtkWidget *window, *drawzone;
int init, moving, slide_pause, im_found;
int imcount, scroll, scrolldir;
gboolean shuffle, repeat, internet_search, stream_play;
gint from_dir;
gchar *script_net, *script_album;
gchar *tempdir, *tempimg;;
GdkPixmap *imagebuffer;
struct image_name_buffer *first, *curimage;


void init_temp_img(  );
void clean_temp(  );
void purge_temp(  );

gchar *up( gchar * str );
gchar *replace( gchar * str, gchar * oldchaine, gchar * newchaine );
gchar *find_file( gchar * path, gchar * filter );
gchar *exists_file( gchar * path, gchar * filter, gchar * ext );
gint count_lines( gchar * str );
gchar *get_line( gint number, gchar * str );
gchar *nextline( char **str );
guint hex_chars_to_int( gchar c, gchar d );
gchar *purge( gchar * str );
gchar *net_purge( gchar * str );
gchar *utf8_decode( gchar * str );
gchar *utf8_encode( gchar * str );
gchar *strip_end_spaces( gchar * string );

gchar *strip_html( gchar * str );
#endif
