/*
 * $Id: lyrc.c,v 1.10 2005/04/07 16:13:27 camico Exp $
 * Author: aweil@corest.com
 *		caligari77@sourceforge.net
 */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <unistd.h>

#include <glib.h>
#include <gtk/gtk.h>

#include <libintl.h>
#define _(String) gettext (String)

#include <xmms/plugin.h>
#include <xmms/configfile.h>
#include <xmms/xmmsctrl.h>

#include "lyrc.h"
#include "lyrc_site.h"

#include "interface-xmms.h"
#include "filetype.h"
#include "globals.h"


/* for handling the loop */
static guint timeout_tag;
/* our loop function. It does everything */

gboolean fexist( gchar * name );

gchar *curfname = NULL;
gchar *lyricsfile = NULL;
gboolean empty = FALSE;
gint check_timer = 1;

/******************************************
This part is the plugin definition for xmms
******************************************/

void lyrc_init( void )
{
	gchar *tmp;

	fname = NULL;
	cur_file_info = NULL;
	flag = FALSE;
	setlocale( LC_ALL, "" );
	bindtextdomain( "lyrc", LOCALEDIR );
	textdomain( "lyrc" );
	lyrics_dir = g_strdup_printf( "%s/.lyrics/", g_get_home_dir(  ) );

	/* create lyrics directory (if needed) */
	tmp = g_strdup_printf( "mkdir %s 2>/dev/null", lyrics_dir );
	system( tmp );
	g_free( tmp );
	tmp = g_strdup_printf( "mkdir %s.advanced/ 2>/dev/null", lyrics_dir );
	system( tmp );
	g_free( tmp );

	/* clean lock files */
	tmp = g_strdup_printf( "\\rm \"%s\"*lock 2>/dev/null", lyrics_dir );
	system( tmp );
	g_free( tmp );
	tmp = g_strdup_printf( "\\rm \"%s\"*info 2>/dev/null", lyrics_dir );
	system( tmp );
	g_free( tmp );
	tmp = g_strdup_printf( "\\rm \"%s.advanced/\"*lock 2>/dev/null", lyrics_dir );
	system( tmp );
	g_free( tmp );

	/*get browsers */
	tmp = g_strdup_printf
		( "which kfmclient MozillaFirebird mozilla-firefox opera mozilla netscape epiphany galeon konqueror w3m lynx > \"%s.advanced/browsers.txt\" 2>/dev/null",
		  lyrics_dir );
	system( tmp );
	g_free( tmp );

	/*create the loop (called every 500ms) */
	timeout_tag = gtk_timeout_add( 500, ( GtkFunction ) lyrc_loop, NULL );
}

void lyrc_cleanup( void )
{
	gtk_timeout_remove( timeout_tag );
	curfname = NULL;
	lyrics_dir = NULL;
	fname = NULL;
	lyricsfile = NULL;
	empty = FALSE;
	flag = FALSE;
}

/******************
HERE START THE PROG
******************/

static void getplayinfo( gint session )
{
	gint pos;
	if( xmms_remote_get_playlist_length( session ) != 0 ) {

		pos = xmms_remote_get_playlist_pos( session );
		curfname = xmms_remote_get_playlist_file( session, pos );
	}
}

gint lyrc_loop( void )
{
	gchar *command;
	static int call = 0;

	if( !lyrics_enabled )
		return TRUE;
	if( !fname )
		fname = ( gchar * ) strdup( "INIT" );
	if( !lyricsfile )
		lyricsfile = ( gchar * ) strdup( "INIT" );

	getplayinfo( coview_session );
	/* No file loaded wait... */
	if( !( curfname ) )
		return ( TRUE );

	/* is it a new file ? */
	if( strcmp( curfname, fname ) != 0 || ( call++ % 5 == 0 && file_age( curfname ) < 5 ) ) {
		/* Yes it is */
		flag = FALSE;
		script_nr = 0;
		fname = ( gchar * ) strdup( curfname );
		freefileinfo( cur_file_info );
		cur_file_info = lyrc_get_file_info( fname );
		/* enough information ? */
		if( !( cur_file_info->artist && cur_file_info->title ) ) {
			/*not enough info */
			lyric_window( NULL );
			return TRUE;
		}
	}

	/* check for upload script's output */
	if( uploading_lyrics ) {
		show_upload_msg(  );
	}

	/* enough information? */
	if( !( cur_file_info->artist && cur_file_info->title ) )
		/* no */
		return TRUE;

	play_artist = ( gchar* ) strdup( cur_file_info->artist );
	play_song = ( gchar* ) strdup( cur_file_info->title );
	play_song = ( gchar* ) replace( play_song, " (live)", "" );
	play_song = ( gchar* ) replace( play_song, " (Live)", "" );
	play_song = ( gchar* ) replace( play_song, " (unplugged)", "" );
	play_song = ( gchar* ) replace( play_song, " (Unplugged)", "" );
	play_song = ( gchar* ) replace( play_song, " (Acoustic)", "" );
	play_song = ( gchar* ) replace( play_song, " (acoustic)", "" );
	play_song = ( gchar* ) replace( play_song, " (Bonus Track)", "" );
	play_song = ( gchar* ) replace( play_song, " (bonus track)", "" );
	play_song = ( gchar* ) replace( play_song, " (Bonus)", "" );
	play_song = ( gchar* ) replace( play_song, " (bonus)", "" );
	play_song = ( gchar* ) replace( play_song, "?", "" );
	play_song = ( gchar* ) replace( play_song, ":", "" );
	play_artist = ( gchar* ) net_purge( play_artist );
	play_artist = ( gchar* ) strip_end_spaces( play_artist );
	play_song = ( gchar* ) net_purge( play_song );
	play_song = ( gchar* ) strip_end_spaces( play_song );
	command = g_strdup_printf( "%s%s - %s.lyrics.xml", lyrics_dir, play_artist, play_song );
	empty = FALSE;

	/* to prevent lyrics for which artist/song contains a "'" to be forgotten */
	command = ( gchar* ) replace( command, "\\'", "'" );

	/* Are we already displaying the lyrics ? */
	if( strcmp( lyricsfile, command ) == 0 && flag && file_age( command ) > 1 ) {
		/* yes, we are, goodbye */
		return ( TRUE );
	}

	/* This is to write future filenames in lowercase... to avoid duplicates etc.
	   ... but support old filenames too */
	if( !fexist( command ) ) {
		g_strdown( play_artist );
		g_strdown( play_song );
		command = g_strdup_printf( "%s%s - %s.lyrics.xml", lyrics_dir, play_artist, play_song );
		command = ( gchar * ) replace( command, "\\'", "'" );
		/* Are we already displaying the lyrics ? */
		if( strcmp( lyricsfile, command ) == 0 && flag && fexist( lyricsfile ) && file_age( command ) > 1 ) {
			/* yes, we are, goodbye */
			return ( TRUE );
		}
	}

	/* Does the lyric file exist?? */
	if( fexist( command ) ) {
		if( fsize( command ) != 0 ) {
			g_free( lyricsfile );
			lyricsfile = command;
			command = g_strdup_printf( "\\rm \"%s%s - %s.lock\" 2>/dev/null", lyrics_dir, play_artist, play_song );
			system( command );
			g_free( command );
			command = g_strdup_printf( "\\rm \"%s%s - %s.info\" 2>/dev/null", lyrics_dir, play_artist, play_song );
			system( command );
			g_free( command );
			lyric_window( lyricsfile );
			flag = TRUE;
			//active_update(FALSE); active_submit(FALSE);
			/*yes, show and exit */
			return ( TRUE );
		} else {
			/*Empty result, try advance */
			if( file_age( command ) > check_timer * 24 * 60 * 60 ) {
				/*Lyrics search is older than 24 hours, redo it */
				g_free( command );
				recheck(  );
				return TRUE;
			}
			g_free( command );
			command = g_strdup_printf( "\\rm \"%s%s - %s.lock\" 2>/dev/null", lyrics_dir, play_artist, play_song );
			system( command );
			empty = TRUE;
		}
	}

	/* We got a result, but an empty one. Maybe an advance result? */
	if( empty ) {
		g_free( command );
		command = g_strdup_printf( "%s.advanced/%s - %s.lyrics.html", lyrics_dir, play_artist, play_song );
		command = ( gchar * ) replace( command, "\\'", "'" );
		/* Are we already displaying the adv-lyrics ? */
		if( strcmp( lyricsfile, command ) == 0 && flag )
			/* yes, we are, goodbye */
			return ( TRUE );
		if( fexist( command ) ) {
			g_free( lyricsfile );
			lyricsfile = command;
			command =
				g_strdup_printf( "\\rm \"%s.advanced/%s - %s.adv.lock\" 2>/dev/null", lyrics_dir, play_artist,
								 play_song );
			system( command );
			g_free( command );
			//active_update(TRUE); active_submit(TRUE);
			lyric_window( lyricsfile );
			flag = TRUE;
			/* yes, show and exit */
			return ( TRUE );
		}
		/* Does the lyric is adv-searched? */
		g_free( command );
		command = g_strdup_printf( "%s.advanced/%s - %s.adv.lock", lyrics_dir, play_artist, play_song );
		if( fexist( command ) ) {
			if( flag )
				return TRUE;
			flag = TRUE;
			g_free( lyricsfile );
			lyricsfile = command;
			/*command=g_strdup_printf("%s/down.html",script_dir); */
			lyric_window( "LOOK" );
			//active_submit(FALSE); active_update(FALSE);
			/* Yes, so wait a little more */
			return TRUE;
		}

		flag = FALSE;
		/* Let's adv-look for the lyrics */
		g_free( command );
		command = g_strdup_printf( "touch \"%s.advanced/%s - %s.adv.lock\"", lyrics_dir, play_artist, play_song );
		system( command );
		g_free( command );
		command =
			g_strdup_printf( "%s/coverviewer/lyrc_adv_script.py %s.advanced/ %s __00__ %s &", DATADIR, lyrics_dir,
							 play_artist, play_song );
		g_free( play_artist );
		g_free( play_song );
		system( command );
		g_free( command );
		return ( TRUE );
	}

	/* Does the lyric is searched? */
	g_free( command );
	command = g_strdup_printf( "%s%s - %s.lock", lyrics_dir, play_artist, play_song );
	if( fexist( command ) ) {
		//if (flag) return TRUE;
		//flag=TRUE;
		g_free( lyricsfile );
		lyricsfile = command;
		lyric_window( "LOOK" );
		//active_submit(FALSE); active_update(FALSE);
		/* Yes, so wait a little more */
		return ( TRUE );
	}

	flag = FALSE;
	/* Let's look for the lyrics */
	g_free( command );
	script_nr = 0;
	get_lyrics( play_artist, play_song, NULL, NULL, 0, script_nr );
	g_free( play_artist );
	g_free( play_song );
	return ( TRUE );
}

gboolean fexist( gchar * name )
{
	FILE *f;
	f = fopen( name, "r" );
	if( f ) {
		fclose( f );
		return TRUE;
	} else
		return FALSE;
}
